<template>
  <div>
    <el-card class="el-card">
      <el-form :inline="true" :model="query" class="query-form" size="mini">
        <el-row>
          <el-form-item class="query-form-item" label="关键字搜索:">
            <el-input v-model="query.key" placeholder="参数关键字搜索" clearable></el-input>
          </el-form-item>
          <el-form-item>
            <el-button-group>
              <el-button type="primary"
                         @click.native="search"
                         icon="el-icon-search">
                搜索
              </el-button>
            </el-button-group>
          </el-form-item>
        </el-row>
      </el-form>
      <el-table v-loading="loading" :data="list" style="width: 100%" border>
        <el-table-column type="index" label="序号" width="50"></el-table-column>
        <el-table-column label="参数名" prop="name"></el-table-column>
        <el-table-column label="参数键" prop="key" width="200"></el-table-column>
        <el-table-column label="参数值" prop="value" width="100"></el-table-column>
        <el-table-column label="提醒类型" prop="type" width="100">

          <template slot-scope="scope">
            <el-tag :type="(scope.row.type) ">
              {{ typeMap[scope.row.type] }}
            </el-tag>
          </template>
        </el-table-column>
        <el-table-column label="参数说明" :show-overflow-tooltip="true">
          <template slot-scope="scope">
            <span>{{ scope.row.remark }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" width="100">
          <template slot-scope="scope">
            <el-button
              type="text"
              size="small"
              @click.native="handleForm(scope.$index, scope.row)"
            >设置
            </el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="query.page"
        :limit.sync="query.limit"
        @pagination="getList"
      />

      <!--表单-->
      <el-dialog
        :title="formMap[formName]"
        :visible.sync="formVisible"
        :close-on-click-modal="false"
        :close-on-press-escape="false"
        :before-close="hideForm"
        width="45%"
        top="5vh"
      >
        <el-form :model="formData" :rules="formRules" ref="dataForm">
          <el-row>
            <el-form-item label="参数名:" prop="name" label-width="100px">
              <el-input
                v-model="formData.name"
                auto-complete="off"
                :disabled="true"
                style="width: 90%"
              ></el-input>
            </el-form-item>

          </el-row>

          <el-row>
            <el-form-item label="参数键:" prop="key" label-width="100px">
              <el-input
                v-model="formData.key"
                auto-complete="off" style="width: 90%"
                :disabled="true"
              ></el-input>
            </el-form-item>
          </el-row>
          <el-row>
            <el-form-item label="参数值" prop="value" label-width="100px">
              <el-input type="" v-model="formData.value" auto-complete="off" style="width: 90%"></el-input>
            </el-form-item>
          </el-row>
          <el-row>
            <el-form-item class="query-form-item" label="提醒类型:" label-width="100px">
              <el-select v-model="formData.type" placeholder="请选择提醒类型" style="width: 90%" disabled>
                <el-option label="" value="0"></el-option>
                <el-option label="库存预警" :value="1"></el-option>
                <el-option label="过期提醒" :value="2"></el-option>
                <el-option label="近效期提醒" :value="3"></el-option>
              </el-select>
            </el-form-item>
          </el-row>

          <el-row>
            <el-form-item label="参数说明:" label-width="100px">
              <el-input
                type="textarea"
                v-model="formData.remark" style="width: 90%"
                :disabled="true"
              ></el-input>
            </el-form-item>
          </el-row>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button @click.native="hideForm">取消</el-button>
          <el-button type="primary" @click.native="formSubmit()" :loading="formLoading"
          >提交
          </el-button>
        </div>
      </el-dialog>
    </el-card>
  </div>
</template>

<script>
import {
  systemParamConfigList,
  systemParamConfigSave,
} from "@/api/system/param/systemParamConfig";
import {remindSetList} from "@/api/system/remindSet";


const formJson = {
  id: "",
  name: "",
  key: "",
  value: "",
  type: null,
  remark: "",
};
export default {
  name: "remindSet",
  data() {
    return {
      query: {
        key: null,
        paramStatus: 1,
        page: 1,
        limit: 20,
      },
      list: [],
      total: 0,
      loading: true,
      index: null,
      formName: null,
      formMap: {
        add: "新增提醒设置",
        update: "提醒设置-编辑",
      },
      formLoading: false,
      formVisible: false,
      formData: formJson,
      formRules: {
        paramValue: [{required: true, message: "请输入参数值", trigger: "blur"}],
        // ,
        // paramStatus: [
        //     {required: true, message: "请选择参数状态", trigger: "change"}
        // ]
      },

      typeMap: {
        1: "库存预警",
        2: "过期提醒",
        3: "近效期提醒",
      },

      deleteLoading: false,
      filterQuery: {}
    };
  },
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.query = {
        paramStatus: 1,
        page: 1,
        limit: 20,
      };
      this.getList();
    },
    onSubmit() {
      this.getList();
    },
    handleCurrentChange(val) {
      this.query.page = val;
      this.getList();
    },
    search() {
      this.query.page = 1;
      this.getList();
    },
    getList() {
      this.loading = true;
      remindSetList(this.query)
        .then((response) => {
          this.loading = false;
          this.list = response.data.list || [];
          this.total = response.data.total || 0;
        })
        .catch(() => {
          this.loading = false;
          this.list = [];
          this.total = 0;
        });
    },
    // 刷新表单
    resetForm() {
      if (this.$refs["dataForm"]) {
        // 清空验证信息表单
        this.$refs["dataForm"].clearValidate();
        // 刷新表单
        this.$refs["dataForm"].resetFields();
        this.getList();
      }
    },
    // 隐藏表单
    hideForm() {
      // 更改值
      this.formVisible = !this.formVisible;
      return true;
    },
    // 显示表单
    handleForm(index, row) {
      this.formVisible = true;
      this.formData = JSON.parse(JSON.stringify(formJson));
      if (row !== null) {
        this.formData = Object.assign({}, row);
      }
      this.formName = "add";
      if (index !== null) {
        this.index = index;
        this.formName = "update";
      }
    },
    formSubmit() {
      // if (!Number.isInteger(parseInt(this.formData.paramValue))) {
      //     this.$message.warning("参数值必须为数字");
      //     return;
      // }
      this.$refs["dataForm"].validate((valid) => {
        if (valid) {
          this.formLoading = true;
          let data = Object.assign({}, this.formData);
          data.paramValue = data.paramValue.trim();
          systemParamConfigSave(data, this.formName)
            .then((response) => {
              this.formLoading = false;
              if (response.code != 20000) {
                this.$message.error(response.message);
                return false;
              }
              this.$message.success("操作成功");
              this.formVisible = false;
              if (this.formName === "add") {
                // 向头部添加数据
                if (response.data && response.data.id) {
                  data.id = response.data.id;
                  this.list.unshift(data);
                }
              } else {
                this.list.splice(this.index, 1, data);
              }
              // 刷新表单
              this.resetForm();
              this.getList();
            })
            .catch(() => {
              this.formLoading = false;
            });
        }
      });
    },
  },
  filters: {
    paramStatusFilterType(paramStatus) {
      const paramStatusMap = {
        0: "gray",
        1: "success",
      };
      return paramStatusMap[paramStatus];
    },
    paramStatusFilterName(paramStatus) {
      const paramStatusMap = {
        0: "禁用",
        1: "正常",
      };
      return paramStatusMap[paramStatus];
    },
  },
  mounted() {
  },
  created() {
    // 加载表格数据
    this.getList();
  },
};
</script>

